import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsStatistics, CmsStatisticsParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询站点统计信息表
 */
export async function pageCmsStatistics(params: CmsStatisticsParam) {
  const res = await request.get<ApiResult<PageResult<CmsStatistics>>>(
    MODULES_API_URL + '/cms/cms-statistics/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询站点统计信息表列表
 */
export async function listCmsStatistics(params?: CmsStatisticsParam) {
  const res = await request.get<ApiResult<CmsStatistics[]>>(
    MODULES_API_URL + '/cms/cms-statistics',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加站点统计信息表
 */
export async function addCmsStatistics(data: CmsStatistics) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/cms-statistics',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改站点统计信息表
 */
export async function updateCmsStatistics(data: CmsStatistics) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/cms-statistics',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除站点统计信息表
 */
export async function removeCmsStatistics(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/cms-statistics/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除站点统计信息表
 */
export async function removeBatchCmsStatistics(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/cms/cms-statistics/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询站点统计信息表
 */
export async function getCmsStatistics(id: number) {
  const res = await request.get<ApiResult<CmsStatistics>>(
    MODULES_API_URL + '/cms/cms-statistics/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
